﻿using System;

namespace DataAccess
{
    public enum DaoType
    {
        InMemory,
        TextFileMemory,
        TextFileDirect,
        SerializedFile
    };

    public class DaoFactory
    {
        /// <summary>
        /// Private constructor: No objects from this class.
        /// </summary>
        private DaoFactory() { }



        public static IDataAccessObject GetDataAccessObject(DaoType daoType)
        {
            switch (daoType)
            {
                case DaoType.InMemory:
                    return new DataAccessObjectInMemory();
                case DaoType.TextFileMemory:
                    return new DataAccessObjectTextFileMemory();
                case DaoType.TextFileDirect:
                    return new DataAccessObjectTextFileDirect();
                case DaoType.SerializedFile:
                    return new DataAccessObjectSerializedFile();
                default:
                    throw new ArgumentException(string.Format("Wrong DaoType: {0}", daoType));
            }
        }
    }
}
