﻿using System;
using System.Collections.Generic;
using Model;

namespace DataAccess
{
     class DataAccessObjectInMemory : IDataAccessObject
    {
        private readonly IDictionary<String, Book> _booksMap = new Dictionary<string, Book>();

        private readonly IList<Book> _booksList = new[]
        {
            new Book("Beginning Android 4 Application Development", "Lee", "478-1-118-19954-1"), 
            new Book("Functional Programming in C#", "Sturm", "978-0-470-74458-1"),
            new Book("Head First Design Patterns", "Freeman", "0-596-007-12")
        };
        public DataAccessObjectInMemory()
        {
            foreach (Book book in _booksList)
            {
                string key = book.Isbn;
                _booksMap[key] = book;
            }
        }

        public Book GetBookByIsbn(string isbn)
        {
            if (_booksMap.ContainsKey(isbn))
            {
                return _booksMap[isbn];
            }
            return null;
        }

        public IList<Book> GetBookByTitle(string title)
        {
            IList<Book> result = new List<Book>();
            foreach (Book book in _booksList)
            {
                if (book.Title.Contains(title))
                {
                    result.Add(book);
                }
            }
            return result;
        }

        public string Description { get { return "In Memory"; } }

        public override string ToString()
        {
            return Description + ": " + _booksList;
        }
    }
}
