﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using DataAccess;
using Model;

namespace LayeredLibrary
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private readonly IDataAccessObject _dao;
        public MainWindow()
        {
            InitializeComponent();
            _dao = DaoFactory.GetDataAccessObject(DaoType.TextFileDirect);
            this.Title = "Simple Library System: " + _dao.Description;
        }

        private void TitleSearchButtonClicked(object sender, RoutedEventArgs e)
        {
            string titleFragment = Textboxtitle.Text;
            try
            {
                IEnumerable<Book> books = _dao.GetBookByTitle(titleFragment);
                if (books.Any())
                {
                    TextBlockOutput.Text = String.Join("\n", books);
                }
                else
                {
                    TextBlockOutput.Text = "No books found with title " + titleFragment;
                }
            }
            catch (LibraryException ex)
            {
                TextBlockOutput.Text = "Problem: " + ex.Message;
            }
        }


        private void IsbnSearchbuttonClickedsbnSearchbuttonClicked(object sender, RoutedEventArgs e)
        {
            String isbn = TextBoxIsbn.Text;
            try
            {
                Book book = _dao.GetBookByIsbn(isbn);
                if (book == null)
                {
                    TextBlockOutput.Text = string.Format("No such book. ISBN={0}", isbn);
                }
                else
                {
                    TextBlockOutput.Text = book.ToString();
                }
            }
            catch (LibraryException ex)
            {
                TextBlockOutput.Text = "Problem: " + ex.Message;
            }
        }
    }
}
